type fd
type header
type header_iter
type lead
type db
type db_iter
type hMagic = HEADER_MAGIC_NO | HEADER_MAGIC_YES
type tag = Rpmtag.t
type header_value =
    Null
  | Char of char
  | Int of int
  | Int32 of int32
  | String of string
  | StringArray of string array
type header_entry = tag * header_value
external _set_error_callback : string -> unit = "ml_error_set_callback"
val set_error_callback : (int -> string -> unit) -> unit
external from_fd : Unix.file_descr -> fd = "ml_fdDup"
external openfile : string -> string -> fd option = "ml_Fopen"
val closefile : 'a -> unit
external lead_read : fd -> lead = "ml__readLead"
external header_read : fd -> hMagic -> header option = "ml_headerRead"
external header_init_iterator : header -> header_iter
  = "ml_headerInitIterator"
external header_next_iterator : header_iter -> header_entry option
  = "ml__headerNextIterator"
external header_get_entry : header -> tag -> header_entry option
  = "ml__headerGetEntry"
external db_open : string -> db option = "ml__rpmdbOpen"
external db_init_iterator : db -> tag -> string -> db_iter option
  = "ml__rpmdbInitIterator"
external db_next_iterator : db_iter -> header option
  = "ml__rpmdbNextIterator"
external read_config : unit -> unit = "ml__rpmReadConfigFiles"
external rpmvercmp : string -> string -> int = "ml_rpmvercmp"
external increace_verbosity : unit -> unit = "ml__rpmIncreaseVerbosity"
external foobar : unit -> db option = "ml_foobar"
val string_of_header_value : header_value -> string
