(* $Id: dbtest.ml,v 1.2 2005/10/31 20:36:24 martin Exp $
 *
 * apttest - rpm -qa functionality. only a bit faster 
 *
 * Copyright (C) 2005  Martin Biely
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

let _ = Rpm.read_config ()

let rpmerror code string = 
  Printf.fprintf stderr "TEST-ERROR: %d -> %s\n" code string
;;

let some_or_fail str = function 
  | Some(x) -> x
  | _ -> failwith (Printf.sprintf "%s is not some!" str)
in

let some_string_or_fail str = function
  | Some(x,Rpm.String(y)) -> y
  | _ -> failwith (Printf.sprintf "%s is not some(,string)!" str)
in

let _ = Rpm.set_error_callback rpmerror in
let db = some_or_fail "dbopen" (Rpm.db_open "") in
let iter = some_or_fail "iter" (Rpm.db_init_iterator db
				   Rpmtag.RPMDBI_PACKAGES "") in

let x = Rpm.foobar () in
Printf.printf "FOOBARING DONE\n"; flush stdout;
let _ = Gc.major() in
Printf.printf "DONE GCING\n"; flush stdout;

let rec loop i = 
  Printf.printf "%d\n" i; flush stdout;
  match Rpm.db_next_iterator iter with
  | Some hdr -> 
      (try 
	 match (Rpm.header_get_entry hdr Rpmtag.NAME) with
	 | Some(_,Rpm.String(name)) -> 
	     let version = some_string_or_fail "version" (Rpm.header_get_entry hdr Rpmtag.VERSION) in
	     let release = some_string_or_fail "version" (Rpm.header_get_entry hdr Rpmtag.RELEASE) in
	     Printf.printf "%s-%s-%s\n" name version release
	 | _ -> ignore(Printf.sprintf "[%04d] error getting name" i)
       with _ -> ()
      );
      loop (i+1)
  | _ -> ()
in
loop 0; Printf.printf "DONE\n"; flush stdout; Gc.major ()
